package utils

import (
	"math"
	"math/rand"
	//"time"
)

type Coordinates struct {
	X float64 `json:"x"`
	Y float64 `json:"y"`
}

func CalculateDistance(a, b Coordinates) float64 {
	return math.Sqrt(math.Pow((a.X-b.X), 2) + math.Pow((a.Y-b.Y), 2))
}

// AverageInt returns the average of an int slice.
func AverageInt(vals []int) float64 {
	sum := 0
	for _, val := range vals {
		sum += val
	}
	return float64(sum) / float64(len(vals))
}

// AverageFloat returns the average of a float slice.
func AverageFloat(vals []float64) float64 {
	sum := 0.0
	for _, val := range vals {
		sum += val
	}
	return sum / float64(len(vals))
}

func Sum(array []int) int {
	var sum int
	for _, value := range array {
		sum += value
	}

	return sum
}

func MaximumCoordinates(coordinates ...[]Coordinates) (x, y float64) {

	x, y = 0, 0

	for _, coordSlice := range coordinates {
		for _, coord := range coordSlice {
			if coord.X > x {
				x = coord.X
			}

			if coord.Y > y {
				y = coord.Y
			}
		}
	}

	return x, y
}

func Shuffle(slice []int, seed int64) []int {

	// Uncomment line below and change rand.Intn to r.Intn for random shuffling from each simulation
	// r := rand.New(rand.NewSource(time.Now().UnixNano()))

	s := rand.NewSource(seed)
	r := rand.New(s)
	for i := range slice {
		//j := rand.Intn(i + 1)
		j := r.Intn(i + 1)
		slice[i], slice[j] = slice[j], slice[i]
	}

	return slice
}

// SumInt returns the sum of an integer slice.
func SumInt(data []int) int {
	sum := 0
	for i := range data {
		sum += data[i]
	}
	return sum
}

// SumFloat returns the sum of a float slice.
func SumFloat(data []float64) float64 {
	sum := 0.0
	for i := range data {
		sum += data[i]
	}
	return sum
}
